#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include <string.h>


struct eleve {
	char nom_complet[50];
	int jour, mois, annee; // date de naissance
	char metier[50];
};
typedef struct eleve eleve_t;

/* Lit dans f les informations d'un/e élève et renvoie un
   eleve_t correspondant. Renvoie NULL si la fin du fichier
   est atteint en cours de lecture. */
eleve_t* lire_eleve(FILE* f){
	eleve_t* res = malloc(sizeof(eleve_t));
	long unsigned int taille_tab = 50; // nombre d'octets des tableaux de chars
	char* s_lu = malloc(50*sizeof(char)); // pour lire avec getline

	// nom complet
	int len = getline(&s_lu, &taille_tab, f);
	s_lu[len-1] = '\0'; // efface le retour à la ligne
	strcpy(res->nom_complet, s_lu);

	// date de naissance
	fscanf(f, "%d %d %d", &res->jour, &res->mois, &res->annee);
	char poubelle;
	fscanf(f, "%c", &poubelle);

	// metier
	len = getline(&s_lu, &taille_tab, f);
	s_lu[len-1] = '\0'; 
	strcpy(res->metier, s_lu);

	free(s_lu);
	return res;
}


/* Ouvre le fichier `filename` et y lit les informations
   d'une classe. Stocke le nombre d'élèves dans *n. */
eleve_t** lire_promo(char* filename, int *n){
	FILE* f = fopen(filename, "r");
	assert(f != NULL);

	// nb d'élèves
	fscanf(f, "%d", n);
	char poubelle;
	fscanf(f, "%c", &poubelle);
	
	eleve_t** res = malloc((*n)*sizeof(eleve_t));


	for (int i = 0; i < *n; ++i)
	{
		eleve_t* e = lire_eleve(f);
		res[i] = e;
	}

	fclose(f);
	return res;
}

int main()
{
	char* fn = "promo_2013.txt";
	int n;
	eleve_t** classe = lire_promo(fn, &n);

	printf("Il y a %d élèves:\n", n);
	for (int i = 0; i < n; ++i)
	{
		eleve_t* e = classe[i];
		printf("%s (né le %d/%d/%d): %s\n\n", 
			e->nom_complet, e->jour, e->mois, e->annee, e->metier);

	}

	for (int i = 0; i < n; ++i)
	{
		free(classe[i]);
	}
	free(classe);

	return 0;
}